/*
www.E2CRE8.be - Brainbox Arduino  - by Bart Huyskens
21/03/2016

IR distance sensor -connector to A3 - look at worksheet "I-AN DIST. DIY"
the IR send led is connected bewteen 0V and 5V
Motor L between 5 and 6
Motor R bewteen 9 and 10

Connect this LCD as follows:
LCD             Brainbox Arduino
GND             GND
VCC             +5V
SDA             SDA/2
SCL             SCL/3
!! Pull up resistors are required - place 4K7 between SDA and 5V and 4K7 between SCL and 5V
*/

#include <Wire.h>  // Comes with Arduino IDE

// Get the LCD I2C Library here: 
// https://bitbucket.org/fmalpartida/new-liquidcrystal/downloads
// Move any other LCD libraries to another folder or delete them
// See Library "Docs" folder for possible commands etc.
#include <LiquidCrystal_I2C.h>

const int analogInPin = A3;  // Analog input pin that the potentiometer is attached to
const int MOTOR_L_PWM =  5; // Left motor PWM signal
const int MOTOR_L_FR =  6;  // Left motor Forward reverse signal (1/0)
const int MOTOR_R_PWM =  9; // Left motor PWM signal
const int MOTOR_R_FR =  10;  // Left motor Forward reverse signal (1/0)

int sensorValue = 1000;  // 1000 to begin - this is an infinite distance


// set the LCD address to 0x27 for a 20 chars 4 line display
// Set the pins on the I2C chip used for LCD connections:
//                    addr, en,rw,rs,d4,d5,d6,d7,bl,blpol
LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);  // Set the LCD I2C address


void setup()
{
  pinMode(MOTOR_L_PWM, OUTPUT);
  pinMode(MOTOR_L_FR, OUTPUT);
  pinMode(MOTOR_R_PWM, OUTPUT);
  pinMode(MOTOR_R_FR, OUTPUT);
  
  lcd.begin(16,2);// initialize library
    lcd.backlight();          //backlight on
    delay(250);
    lcd.noBacklight();        //backlight off
    delay(250);
    lcd.backlight();          //backlight on
  lcd.clear();   
}
 
 
void loop()
{
sensorValue = analogRead(analogInPin);              // read the value of the IR distance sensor

lcd.setCursor(0,0);                                 // set cursor to positon x,y
lcd.print("AN3 Value:");                            // print text on the LCD
lcd.print(sensorValue);                             // print the value of the variable on the LCD

if (sensorValue > 850) // no object detected
{

digitalWrite(MOTOR_L_FR, LOW);    //Forward
analogWrite(MOTOR_L_PWM, 200);    // PWM 200/255
digitalWrite(MOTOR_R_FR, LOW);    //Forward
analogWrite(MOTOR_R_PWM, 220);    // PWM 200/255
                         
delay(100);                                      

}

else
{
digitalWrite(MOTOR_L_FR, HIGH);    //Reverse
analogWrite(MOTOR_L_PWM, 255);    // STOP
digitalWrite(MOTOR_R_FR, HIGH);    //Forward
analogWrite(MOTOR_R_PWM, 255);    // STOP

delay(500);  

digitalWrite(MOTOR_L_FR, HIGH);    //Reverse
analogWrite(MOTOR_L_PWM, 100);    // PWM (255-55)/255
digitalWrite(MOTOR_R_FR, HIGH);    //Reverse
analogWrite(MOTOR_R_PWM, 100);    // PWM (255-55)/255

delay(1000);   

digitalWrite(MOTOR_L_FR, HIGH);    //Reverse
analogWrite(MOTOR_L_PWM, 100);    // PWM (255-55)/255
digitalWrite(MOTOR_R_FR, LOW);    //Forward
analogWrite(MOTOR_R_PWM, 0);    // STOP

 delay(1000);  
 
 digitalWrite(MOTOR_L_FR, LOW);    //Reverse
analogWrite(MOTOR_L_PWM, 0);    // PWM (255-55)/255
digitalWrite(MOTOR_R_FR, LOW);    //Forward
analogWrite(MOTOR_R_PWM, 0);    // STOP

 delay(100);  

}
}
